// SpiegelZahlDialog.java                       MM 2013
// Model                                        AZ 2005

import Tools.IO.*;                          // Eingaben

/**
 * Erzeugen einer symmetrische Zahl durch Spiegelung.
 * Spieldialog mittels Konsole/Tastatur.
 */
public class SpiegelZahlDialog
{
/**
 * Startet Dialog mittels Konsole/Tastatur,
 * ermoeglich Spielwiederholung.
 */
  public void starten()
  {
// Problem einrichten
    SpiegelZahl spiegel = new SpiegelZahl();

// Regeln
    System.out.println();
    System.out.println( spiegel.spielRegeln());
    System.out.println();
    IOTools.readLine( "Weiter (ENTER) ");

// Wiederholung
    char weiter = 'j';
    do
    {
// Zuruecksetzen
      spiegel.reset();

// Dialog
      System.out.println();
      spielen( spiegel);

// Auswertung
      System.out.println();
      System.out.println( spiegel.auswertung());

// Weiter
      System.out.println();
      weiter = IOTools.readChar( "Noch einmal (j/n) ");
    } while( weiter == 'j');

// Beenden
    System.out.println();
    System.out.println( "Programm beendet!");
  }

/**
 * Dialog zum Spiel,
 * liest Startzahl ein, addiert Spiegel
 * bis Palindrom entstanden ist oder Nutzer abbricht.
 * @param spiegel aktuelle Spiel
 */
  private void spielen( SpiegelZahl spiegel)
  {
// Eingabe einer Zahl
    while( true)
    {
      try
      {
        String eingabe = IOTools.readLine
          ( "Natuerliche Zahl eingeben: ");
        spiegel.setZahl( eingabe);
        break;
      }
      catch( Exception e)
      {
        System.err.println( "Eingabefehler!\n" + e);
      }
    }

// Eingabe der Schrittweite
    int schrittweite;
    do
    {
      schrittweite =
        IOTools.readInteger( "Schrittweite eingeben: ");
    } while( schrittweite < 1);

// Spiegeln
    while( !spiegel.spiegeln( schrittweite))
    {
      System.out.print( spiegel);
      if(( IOTools.readLine
           ( " Weiter j/n: ")).equals( "n")) break;
    }

// Ergebnis
    System.out.println( spiegel);
  }

/* ------------------------------------------------- */
                                            // Programm
/**
 * Startet das Spiegelzahlprogramm.
 */
  public static void main( String[] args)
  {
// Problem einrichten
    SpiegelZahlDialog dialog
    = new SpiegelZahlDialog();

// Problem starten
    dialog.starten();
 }
}

/* ------------------------------------------------- */

// Testwerte:
// 789             -> Schrittzahl  4 :          66066
// 53978           -> Schrittzahl  7 :       88255288
// 52007615407     -> Schrittzahl  8 : 89887611678898
// 8396501         -> Schrittzahl 17 : 44440011004444
// 456789900345345 -> nach 46000 Schritten
//                    kein Ergebnis!

